#include <SFML/Graphics.hpp>
#include <iostream>
#include <fstream>
class Map
{
public:
	Map();
	MapElement Block[20][12];
	sf::Image mapImage;
	int sceneset;
	int npcset;
	int propset;
	sf::Vector2f npcpos;
	sf::Vector2f proppos;
	sf::Vector2f catpos;
	void WipeSolids();
	void Render(sf::RenderWindow& win);
	void LoadFromFile(const char* filename, int lev);
};

Map::Map()
{
	int t;
	mapImage.LoadFromFile("assets/sprites.png");
	mapImage.SetSmooth(false);
	WipeSolids();
	for(int j=0; j<12; j++)
	{
		for(int i=0; i<20; i++)
		{
			Block[i][j].SetGraphics(mapImage);
			if(j>7) t=(rand()%3)*32; else t=32+(rand()%2)*32;
			Block[i][j].spr.SetSubRect(sf::IntRect((32+t), 32, (64+t), 64));
			Block[i][j].spr.SetPosition(float(i*32), float(j*32));
			if(t==0) Block[i][j].isSolid=true;
		}
	}
}

void Map::Render(sf::RenderWindow& win)
{
	for(int j=0; j<12; j++)
	{
		for(int i=0; i<20; i++)
		{
			Block[i][j].Render(win);
		}
	}
}

void Map::LoadFromFile(const char* filename, int lev)
{
	int t;
	int x1, y1, x2, y2, x3, y3;;
	std::ifstream fin(filename);

	for(int l=0; l<lev; l++)
	{
		WipeSolids();
		fin >> sceneset;
		fin >> npcset;
		fin >> propset;
		fin >> x1;
		fin >> y1;
		fin >> x2;
		fin >> y2;
		fin >> x3;
		fin >> y3;
		npcpos=sf::Vector2f(x1*32, y1*32);
		proppos=sf::Vector2f(x2*32, y2*32);
		catpos=sf::Vector2f(x3*32, y3*32);

		for(int j=0; j<12; j++)
		{
			for(int i=0; i<20; i++)
			{
				fin >> t;
				if(t==0 || t==2 || t==3) Block[i][j].isSolid=true;
				if(t==3) t=1;
				Block[i][j].index = t;
				Block[i][j].SetGraphics(mapImage);
				Block[i][j].spr.SetSubRect(sf::IntRect(32+(t*32), (sceneset*32), 64+(t*32), 32+(sceneset*32)));
				Block[i][j].spr.SetPosition(float(i*32), float(j*32));

			}
		}
	}
}

void Map::WipeSolids()
{
	for(int j=0; j<12; j++)
	{
		for(int i=0; i<20; i++)
		{
			Block[i][j].isSolid=false;
		}
	}
}



